JlCompress Class Reference

Utility class for typical operations. More...

`#include <JlCompress.h>`

## Static Public Member Functions

static bool | copyData (QIODevice &inFile, QIODevice &outFile)
static QStringList | extractDir (QuaZip &zip, const QString &dir)
static QStringList | getFileList (QuaZip *zip)
static QString | extractFile (QuaZip &zip, QString fileName, QString fileDest)
static QStringList | extractFiles (QuaZip &zip, const QStringList &files, const QString &dir)
static bool | compressFile (QuaZip *zip, QString fileName, QString fileDest)
| Compress a single file.
static bool | compressSubDir (QuaZip *parentZip, QString dir, QString parentDir, bool recursive, QDir::Filters filters)
| Compress a subdirectory.
static bool | extractFile (QuaZip *zip, QString fileName, QString fileDest)
| Extract a single file.
static bool | removeFile (QStringList listFile)
| Remove some files.
static bool | compressFile (QString fileCompressed, QString file)
| Compress a single file.
static bool | compressFiles (QString fileCompressed, QStringList files)
| Compress a list of files.
static bool | compressDir (QString fileCompressed, QString dir=QString(), bool recursive=true)
| Compress a whole directory.
static bool | compressDir (QString fileCompressed, QString dir, bool recursive, QDir::Filters filters)
| Compress a whole directory.
static QString | extractFile (QString fileCompressed, QString fileName, QString fileDest=QString())
| Extract a single file.
static QStringList | extractFiles (QString fileCompressed, QStringList files, QString dir=QString())
| Extract a list of files.
static QStringList | extractDir (QString fileCompressed, QString dir=QString())
| Extract a whole archive.
static QStringList | extractDir (QString fileCompressed, QTextCodec *fileNameCodec, QString dir=QString())
| Extract a whole archive.
static QStringList | getFileList (QString fileCompressed)
| Get the file list.
static QString | extractFile (QIODevice *ioDevice, QString fileName, QString fileDest=QString())
| Extract a single file.
static QStringList | extractFiles (QIODevice *ioDevice, QStringList files, QString dir=QString())
| Extract a list of files.
static QStringList | extractDir (QIODevice *ioDevice, QString dir=QString())
| Extract a whole archive.
static QStringList | extractDir (QIODevice *ioDevice, QTextCodec *fileNameCodec, QString dir=QString())
| Extract a whole archive.
static QStringList | getFileList (QIODevice *ioDevice)
| Get the file list.

## Detailed Description

Utility class for typical operations.

This class contains a number of useful static functions to perform simple operations, such as mass ZIP packing or extraction.

## Member Function Documentation

## compressFile() [1/2]

bool JlCompress::compressFile | ( | QuaZip * | zip,
|  | QString | fileName,
|  | QString | fileDest
| ) |  |

static

Compress a single file.

Parameters

  zip | Opened zip to compress the file to.
  fileName | The full path to the source file.
  fileDest | The full name of the file inside the archive.

Returns
  true if success, false otherwise.

References QuaZipFile::close(), QuaZip::getMode(), QuaZipFile::getZipError(), QuaZip::mdAdd, QuaZip::mdAppend, QuaZip::mdCreate, QuaZipFile::open(), and QuaZipFile::setFileName().

Referenced by compressFile(), compressFiles(), and compressSubDir().

## compressSubDir()

bool JlCompress::compressSubDir | ( | QuaZip * | parentZip,
|  | QString | dir,
|  | QString | parentDir,
|  | bool | recursive,
|  | QDir::Filters | filters
| ) |  |

static

Compress a subdirectory.

Parameters

  parentZip | Opened zip containing the parent directory.
  dir | The full path to the directory to pack.
  parentDir | The full path to the directory corresponding to the root of the ZIP.
  recursive | Whether to pack sub-directories as well or only files.

Returns
  true if success, false otherwise.

References QuaZipFile::close(), compressFile(), compressSubDir(), QuaZip::getMode(), QuaZip::getZipName(), QuaZip::mdAdd, QuaZip::mdAppend, QuaZip::mdCreate, and QuaZipFile::open().

Referenced by compressDir(), and compressSubDir().

## extractFile() [1/3]

bool JlCompress::extractFile | ( | QuaZip * | zip,
|  | QString | fileName,
|  | QString | fileDest
| ) |  |

static

Extract a single file.

Parameters

  zip | The opened zip archive to extract from.
  fileName | The full name of the file to extract.
  fileDest | The full path to the destination file.

Returns
  true if success, false otherwise.

References QuaZipFile::close(), QuaZip::getCurrentFileInfo(), QuaZip::getMode(), QuaZipFileInfo64::getPermissions(), QuaZipFile::getZipError(), QuaZipFileInfo64::isSymbolicLink(), QuaZip::mdUnzip, QuaZipFile::open(), removeFile(), and QuaZip::setCurrentFile().

## removeFile()

bool JlCompress::removeFile | ( | QStringList | listFile | ) |

static

Remove some files.

Parameters

  listFile | The list of files to remove.

Returns
  true if success, false otherwise.

Referenced by extractFile().

## compressFile() [2/2]

bool JlCompress::compressFile | ( | QString | fileCompressed,
|  | QString | file
| ) |  |

static

Compress a single file.

Parameters

  fileCompressed | The name of the archive.
  file | The file to compress.

Returns
  true if success, false otherwise.

References QuaZip::close(), compressFile(), QuaZip::getZipError(), QuaZip::mdCreate, and QuaZip::open().

## compressFiles()

bool JlCompress::compressFiles | ( | QString | fileCompressed,
|  | QStringList | files
| ) |  |

static

Compress a list of files.

Parameters

  fileCompressed | The name of the archive.
  files | The file list to compress.

Returns
  true if success, false otherwise.

References QuaZip::close(), compressFile(), QuaZip::getZipError(), QuaZip::mdCreate, and QuaZip::open().

## compressDir() [1/2]

bool JlCompress::compressDir | ( | QString | fileCompressed,
|  | QString | dir = `QString()`,
|  | bool | recursive = `true`
| ) |  |

static

Compress a whole directory.

Does not compress hidden files. See compressDir(QString, QString, bool, QDir::Filters).

Parameters

  fileCompressed | The name of the archive.
  dir | The directory to compress.
  recursive | Whether to pack the subdirectories as well, or just regular files.

Returns
  true if success, false otherwise.

References compressDir().

Referenced by compressDir().

## compressDir() [2/2]

bool JlCompress::compressDir | ( | QString | fileCompressed,
|  | QString | dir,
|  | bool | recursive,
|  | QDir::Filters | filters
| ) |  |

static

Compress a whole directory.

Unless filters are specified explicitly, packs only regular non-hidden files (and subdirs, if `recursive` is true). If filters are specified, they are OR-combined with `QDir::AllDirs|QDir::NoDotAndDotDot` when searching for dirs and with `QDir::Files` when searching for files.

Parameters

  fileCompressed | path to the resulting archive
  dir | path to the directory being compressed
  recursive | if true, then the subdirectories are packed as well
  filters | what to pack, filters are applied both when searching for subdirs (if packing recursively) and when looking for files to pack

Returns
  true on success, false otherwise

References QuaZip::close(), compressSubDir(), QuaZip::getZipError(), QuaZip::mdCreate, and QuaZip::open().

## extractFile() [2/3]

QString JlCompress::extractFile | ( | QString | fileCompressed,
|  | QString | fileName,
|  | QString | fileDest = `QString()`
| ) |  |

static

Extract a single file.

Parameters

  fileCompressed | The name of the archive.
  fileName | The file to extract.
  fileDest | The destination file, assumed to be identical to file if left empty.

Returns
  The list of the full paths of the files extracted, empty on failure.

## extractFiles() [1/2]

QStringList JlCompress::extractFiles | ( | QString | fileCompressed,
|  | QStringList | files,
|  | QString | dir = `QString()`
| ) |  |

static

Extract a list of files.

Parameters

  fileCompressed | The name of the archive.
  files | The file list to extract.
  dir | The directory to put the files to, the current directory if left empty.

Returns
  The list of the full paths of the files extracted, empty on failure.

## extractDir() [1/4]

QStringList JlCompress::extractDir | ( | QString | fileCompressed,
|  | QString | dir = `QString()`
| ) |  |

static

Extract a whole archive.

Parameters

  fileCompressed | The name of the archive.
  dir | The directory to extract to, the current directory if left empty.

Returns
  The list of the full paths of the files extracted, empty on failure.

## extractDir() [2/4]

QStringList JlCompress::extractDir | ( | QString | fileCompressed,
|  | QTextCodec * | fileNameCodec,
|  | QString | dir = `QString()`
| ) |  |

static

Extract a whole archive.

Parameters

  fileCompressed | The name of the archive.
  fileNameCodec | The codec to use for file names.
  dir | The directory to extract to, the current directory if left empty.

Returns
  The list of the full paths of the files extracted, empty on failure.

References QuaZip::setFileNameCodec().

## getFileList() [1/2]

QStringList JlCompress::getFileList | ( | QString | fileCompressed | ) |

static

Get the file list.

Returns
  The list of the files in the archive, or, more precisely, the list of the entries, including both files and directories if they are present separately.

## extractFile() [3/3]

QString JlCompress::extractFile | ( | QIODevice * | ioDevice,
|  | QString | fileName,
|  | QString | fileDest = `QString()`
| ) |  |

static

Extract a single file.

Parameters

  ioDevice | pointer to device with compressed data.
  fileName | The file to extract.
  fileDest | The destination file, assumed to be identical to file if left empty.

Returns
  The list of the full paths of the files extracted, empty on failure.

## extractFiles() [2/2]

QStringList JlCompress::extractFiles | ( | QIODevice * | ioDevice,
|  | QStringList | files,
|  | QString | dir = `QString()`
| ) |  |

static

Extract a list of files.

Parameters

  ioDevice | pointer to device with compressed data.
  files | The file list to extract.
  dir | The directory to put the files to, the current directory if left empty.

Returns
  The list of the full paths of the files extracted, empty on failure.

## extractDir() [3/4]

QStringList JlCompress::extractDir | ( | QIODevice * | ioDevice,
|  | QString | dir = `QString()`
| ) |  |

static

Extract a whole archive.

Parameters

  ioDevice | pointer to device with compressed data.
  dir | The directory to extract to, the current directory if left empty.

Returns
  The list of the full paths of the files extracted, empty on failure.

## extractDir() [4/4]

QStringList JlCompress::extractDir | ( | QIODevice * | ioDevice,
|  | QTextCodec * | fileNameCodec,
|  | QString | dir = `QString()`
| ) |  |

static

Extract a whole archive.

Parameters

  ioDevice | pointer to device with compressed data.
  fileNameCodec | The codec to use for file names.
  dir | The directory to extract to, the current directory if left empty.

Returns
  The list of the full paths of the files extracted, empty on failure.

References QuaZip::setFileNameCodec().

## getFileList() [2/2]

QStringList JlCompress::getFileList | ( | QIODevice * | ioDevice | ) |

static

Get the file list.

Returns
  The list of the files in the archive, or, more precisely, the list of the entries, including both files and directories if they are present separately.

The documentation for this class was generated from the following files:

- quazip/JlCompress.h
- quazip/JlCompress.cpp